std::atomic_ref::wait(3)

NAME
std::atomic_ref::wait - std::atomic_ref::wait

Synopsis
   void wait( T old,
   std::memory_order order = std::memory_order::seq_cst ) const
   noexcept; (since C++20)
   void wait( T old,
   std::memory_order order = std::memory_order::seq_cst ) const
   volatile noexcept;
   Performs atomic waiting operations. Behaves as if it repeatedly performs the
   following steps:
     * Compare the value representation of this->load(order) with that of old.
          * If those are equal, then blocks until *this is notified by notify_one() or
            notify_all(), or the thread is unblocked spuriously.
          * Otherwise, returns.
   These functions are guaranteed to return only if value has changed, even if
   underlying implementation unblocks spuriously.

Parameters
   old - the value to check the atomic_ref's object no longer contains
   order - the memory synchronization ordering for this operation: must not be
           std::memory_order::release or std::memory_order::acq_rel

Return value
   (none)

Notes
   This form of change-detection is often more efficient than simple polling or pure
   spinlocks.
   Due to the ABA problem, transient changes from old to another value and back to old
   might be missed, and not unblock.
   The comparison is bitwise (similar to std::memcmp); no comparison operator is used.
   Padding bits that never participate in an object's value representation are ignored.

Example
    This section is incomplete
    Reason: no example

See also
   notify_one notifies at least one thread waiting on the atomic object
   (C++20) (public member function)
   notify_all notifies all threads blocked waiting on the atomic object
   (C++20) (public member function)
   atomic_notify_one notifies a thread blocked in atomic_wait
   (C++20) (function template)
   atomic_notify_all notifies all threads blocked in atomic_wait
   (C++20) (function template)